#include <ARCH/IO.H>
#include <KERNEL/VM.H>

void HALT(void)
{
	KERNEL$DI();
	__critical_printf("SYSTEM HALTED");
	while (1) __asm__ volatile ("HLT":::"memory");
}

void RESET(void)
{
	KERNEL$DI();
	*(__u16 *)(KERNEL$ZERO_BANK + 0x472) = 0x1234;
	__critical_printf("RESETTING");
	while (1) {
		unsigned i;
		for (i = 0; i < 100000; i++) {
			if (!(io_inb(0x62) & 0x02)) break;
			KERNEL$UDELAY(2);
		}
		KERNEL$UDELAY(50);
		io_outb(0x64, 0xfe);
		KERNEL$UDELAY(50);
	}
}
