#include <DOC.H>

$DOC_INTERFACE(AST_HEAD,

$TYPE_MACRO_STRUCTURE_ENTRIES

$INCLUDES(
$INCLUDE(SPAD/AC.H)
)

$FORMAT(struct s { AST_HEAD; more entries ...; };)

$DESCRIPTION(
This macro can be prepended at the beginning of a structure to add AST entries.
The strucure with $CODE(AST_HEAD) at the beginning can be cast to structure
$CODE(AST) and can be passed to functions and macros that expect $CODE(AST).

$NP

$CODE(AST_HEAD) adds an entry with name $CODE(fn) to the structure.
It can add more architecture-specific entries.
)

$SEE_ALSO($LINK(DECL_AST, DECL_AST), $LINK(AST, AST))

)

$IGNORE(
vim: textwidth=80
)
