#include <DOC.H>

$DOC_INTERFACE(SPL_BUSY,

$TYPE_MACRO_EXPRESSION

$ENVIRONMENT(User/kernel, Sync/async, No, Any, No)

$INCLUDES(
$INCLUDE(SPAD/AC.H)
)

$FORMAT(if (SPL_BUSY($ARG(spl))) ...)

$DESCRIPTION(
This is the equivalent of
$CODE($LINK(SPLX_BUSY,SPLX_BUSY)($LINK(SPL_X,SPL_X)($ARG(spl)))). See definition
of these macros.
)

$ARGUMENTS(
$ARGUMENT(spl,
A constant number in the range 0 $NDASH 30.
)
)

$RETURNS(
Returns non-zero if there is an AST or IORQ pending on or above $ARG(spl).
)

$IMPLEMENTATION(The macro performs a
compile-time check for correct argument.
)

$SEE_ALSO($LINK(SPL_X, SPL_X),
$LINK(SPLX_BUSY, SPLX_BUSY))

)

$IGNORE(
vim: textwidth=80
)
