#include <DOC.H>

$DOC_INTERFACE(__LONG_LONG_SUPPORTED,

$TYPE_MACRO

$INCLUDES(
$INCLUDE(SYS/TYPES.H)
)

$FORMAT(#ifdef __LONG_LONG_SUPPORTED)

$DESCRIPTION(
This macro is defined if the compiler supports long long and unsigned long long
types. When this macro is defined, additional constants
$LINK(MAXLLONG,MAXLLONG),
$LINK(MINLLONG,MINLLONG),
$LINK(MAXULLONG,MAXULLONG),
$LINK(__LLONG_SGN_BIT,__LLONG_SGN_BIT) are defined.
)
$NP
The code may assume that types $LINK(__U64, __u64) and $LINK(__S64, __s64) are
always present, but it should not assume that long long is present unless this
macro is defined.

$SEE_ALSO(
$LINK(MAXLLONG,MAXLLONG),
$LINK(MINLLONG,MINLLONG),
$LINK(MAXULLONG,MAXULLONG),
$LINK(__LLONG_SGN_BIT,__LLONG_SGN_BIT)
)

)

$IGNORE(
vim: textwidth=80
)
