#include <DOC.H>

$DOC_INTERFACE(__PRINTF_ATTR__,

$TYPE_MACRO_TYPE_ATTRIBUTE

$INCLUDES(
$INCLUDE(SYS/TYPES.H)
)

$FORMAT(void __PRINTF_ATTR__($ARG(a),$ARG(b)) function(args...);)

$DESCRIPTION(
This macro expands to a compiler-specific attribute telling that the function
processes a printf-like format string.
$NP
It advises the compiler to print a warning if argument types do not match "%"
strings in the format string.
)

$ARGUMENTS(
$ARGUMENT(a, This argument is integer constant specifying the argument number
(starting from 1) that specifies the format string.)
$ARGUMENT(b, This argument is integer constant specifying the argument number
(starting from 1) where variable arguments start.)
)

$IMPLEMENTATION(When using the gcc compiler, this macro expands to
$CODE(__attribute__((__format__(__printf__(a,b))))).

$SEE_ALSO($LINK(__SCANF_ATTR__,__SCANF_ATTR__))
)

)

$IGNORE(
vim: textwidth=80
)
