#include <DOC.H>

$DOC_INTERFACE(__sec_t_format,

$TYPE_MACRO_STRING

$INCLUDES(
$INCLUDE(SYS/TYPES.H)
)

$FORMAT(__sec_t_format)

$DESCRIPTION(
This macro expands to a format string qualifier that specifies printf or scanf
arguments for $LINK(__SEC_T, __sec_t) or $LINK(__USEC_T, __usec_t) types.
Because
different
configurations may have different definitions for these types, an extra
definition for the qualifier is needed.
)

$EXAMPLE($CODE($NL
__sec_t variable = 3;$NL
_printf("%"__sec_t_format"u\n", variable);$NL
))

$SEE_ALSO($LINK(__SEC_T, __sec_t), $LINK(__USEC_T, __usec_t))

)

$IGNORE(
vim: textwidth=80
)
