static void ATA_SELECT_DEVICE(APORT *p, ATA_ATTACH_PARAM *me, ATA_ATTACH_PARAM *other, BIORQ *b1);

static void ATA_END_REQUEST(APORT *p, int status)
{
	unsigned dev;
	ATARQ *rq;
	ATA_ATTACH_PARAM *me, *other;
	BIORQ *b1;
	rq = p->current_rq;
	rq->status = status;
	KERNEL$DEL_TIMER(&p->timeout);
	p->current_rq = NULL;
	END_REQUEST_EXTRA;
	dev = rq->device;
	rq->done(rq);
	me = p->device[dev].attached;
	if (__likely(!(other = p->device[dev ^ 1].attached)) || __likely(!(b1 = other->probe_queue(other)))) {
		while (__unlikely(me->dequeue(me))) ;
	} else {
		ATA_SELECT_DEVICE(me->port, me, other, b1);
	}
}

static void ATA_SELECT_DEVICE(APORT *p, ATA_ATTACH_PARAM *me, ATA_ATTACH_PARAM *other, BIORQ *b1)
{
	BIORQ *b0;
	long c;
	b0 = me->probe_queue(me);
	compare_again:
	if (!b0) {
		deq_other:
		me = other;
		goto deq_me;
	}
	if (!b1) {
		deq_me:
		while (__unlikely(me->dequeue(me))) ;
		return;
	}
	c = BIOQUE$COMPARE_REQUESTS(b0, me->biosched, b1, other->biosched);
	if (c < 0) {
		if (__unlikely(!me->dequeue(me))) goto deq_other;
		b0 = me->probe_queue(me);
		goto compare_again;
	} else {
		if (__unlikely(!other->dequeue(other))) goto deq_me;
		b1 = other->probe_queue(other);
		goto compare_again;
	}
}

static void ATA_DEQUEUE(APORT *p)
{
	ATA_ATTACH_PARAM *a0 = p->device[0].attached;
	ATA_ATTACH_PARAM *a1 = p->device[1].attached;
	if (__unlikely(!a0)) {
		if (__unlikely(!a1)) return;
		while (__unlikely(a1->dequeue(a1))) ;
		return;
	} else if (!a1) {
		while (__unlikely(a0->dequeue(a0))) ;
		return;
	}
	ATA_SELECT_DEVICE(p, a0, a1, a1->probe_queue(a1));
}

#undef END_REQUEST_EXTRA
