#define RESET_FF_TIMEOUT	(JIFFIES_PER_SECOND * 1)
#define POLL_TIME		(JIFFIES_PER_SECOND / 10)

{
	__u8 status;
	int slept, reset, reset_verbose;

/* Drain pending requests */

	ATA_LOCK(p);

/* Test for BUSY */

	reset = 0;
	after_reset:

/* Linux source says that non-ready slave can break master detection */
	if (WAIT_FOR_OTHER_DEVICE && !p->device[j ^ 1].attached) {
		slept = 0;
		after_other_sleep:
		ATA_OUT_DRIVE(p, (j ^ 1) * ATA_DEVICE_DRIVE);
		KERNEL$UDELAY(10);
		status = ATA_IN_STATUS(p);
		if (status & ATA_STATUS_BSY && status != 0xff) {
			if (slept >= probe_timeout / POLL_TIME) goto other_not_ready;
			KERNEL$SLEEP(POLL_TIME);
			slept++;
			goto after_other_sleep;
		}
		other_not_ready:;
	}

	slept = 0;
	after_sleep:
	ATA_OUT_DRIVE(p, j * ATA_DEVICE_DRIVE);
	KERNEL$UDELAY(10);
	status = ATA_IN_STATUS(p);
	if (status & ATA_STATUS_BSY) {
		if (slept >= probe_timeout / POLL_TIME) {
			reset_verbose = 0;
			goto try_reset;
		}
		if (status == 0xff && !reset && slept >= RESET_FF_TIMEOUT / POLL_TIME) goto detach_cont;
		KERNEL$SLEEP(POLL_TIME);
		slept++;
		goto after_sleep;
	}
	if (reset == 1) {
		int error = ATA_IN_ERROR(p);
		if (error != 1) {
			KERNEL$SYSLOG(__SYSLOG_HW_ERROR, *ap->dev_name, "RESET FAILED, STATUS %02X, ERROR %02X", status, error);
			goto detach_cont;
		}
	}
	if (status & ATA_STATUS_DF) {
		detach_cont:
		ATA_UNLOCK(p);
		{
			FAIL_CODE;
			__unreachable_code();
		}
	}
	if (status & ATA_STATUS_DRQ) {
		char *str;
		reset_verbose = 1;
		try_reset:
		if (reset) goto detach_cont;
		if (atapi) {
			reset = 3;
			ATA_OUT_CMD(p, ATA_CMD_DEVICE_RESET);
			KERNEL$UDELAY(10);
			str = "RESETTING DEVICE";
		} else if (!p->device[j ^ 1].attached && !ACTRLINIT_CANT_RESET) {
			reset = 1;
			ATA_OUT_CTRL(p, ATA_CTRL_ONE | ATA_CTRL_SRST);
			KERNEL$UDELAY(10);
			ATA_OUT_CTRL(p, ATA_CTRL_ONE);
			KERNEL$UDELAY(10);
			str = "RESETTING BUS";
		} else {
			reset = 2;
			ATA_OUT_FEATURES(p, ATA_FEATURE_NOP_NOP);
			KERNEL$UDELAY(10);
			ATA_OUT_CMD(p, ATA_CMD_NOP);
			KERNEL$UDELAY(10);
			str = "SENDING NOP";
		}
		if (reset_verbose)
			KERNEL$SYSLOG(__SYSLOG_HW_ERROR, *ap->dev_name, "DRIVE LEFT IN INCONSISTENT STATE (STATUS %02X), %s", status, str);
		goto after_reset;
	}
	if (!atapi && !(status & ATA_STATUS_DRDY)) {
		goto detach_cont;
	}
	INIT_XFER;
	ATA_UNLOCK(p);

/* Now we are surely attached */

#if 0
	if (p->aport_flags & APORT_SATA && p->device[j].dev_flags & IDE_XFER_MASK) {
		p->device[j].dev_flags &= ~IDE_XFER_MASK;
		KERNEL$SYSLOG(__SYSLOG_HW_INCOMPATIBILITY, *ap->dev_name, "CAN'T SET TRANSFER MODE ON SATA");
	}
#endif
}

#undef WAIT_FOR_OTHER_DEVICE
#undef ACTRLINIT_CANT_RESET
#undef FAIL_CODE
