#ifndef __NIC_RTLREG_H
#define __NIC_RTLREG_H

#define RTL_REGSPACE	0x0100

#define  RTL_RX_ROK		0x0001
#define  RTL_RX_FAE		0x0002
#define  RTL_RX_CRC		0x0004
#define  RTL_RX_LONG		0x0008
#define  RTL_RX_RUNT		0x0010
#define  RTL_RX_ISE		0x0020
#define  RTL_RX_BAR		0x2000
#define  RTL_RX_PAM		0x4000
#define  RTL_RX_MAR		0x8000
#define RTL_IDR0	0x0000
#define RTL_IDR1	0x0001
#define RTL_IDR2	0x0002
#define RTL_IDR3	0x0003
#define RTL_IDR4	0x0004
#define RTL_IDR5	0x0005
#define RTL_MAR0	0x0008
#define RTL_MAR1	0x0009
#define RTL_MAR2	0x000a
#define RTL_MAR3	0x000b
#define RTL_MAR4	0x000c
#define RTL_MAR5	0x000d
#define RTL_MAR6	0x000e
#define RTL_MAR7	0x000f
#define RTL_TSD0	0x0010
#define RTL_TSD1	0x0014
#define RTL_TSD2	0x0018
#define RTL_TSD3	0x001c
#define  RTL_TSD_SIZE_SHIFT	0
#define  RTL_TSD_OWN		0x00002000
#define  RTL_TSD_TUN		0x00004000
#define  RTL_TSD_TOK		0x00008000
#define  RTL_TSD_ERTXTH_SHIFT	16
#define  RTL_TSD_ERTXTH_MASK	0x3f
#define  RTL_TSD_NCC_SHIFT	24
#define  RTL_TSD_CDH		0x10000000
#define  RTL_TSD_WC		0x20000000
#define  RTL_TSD_TABT		0x40000000
#define  RTL_TSD_CRS		0x80000000
#define RTL_TSAD0	0x0020
#define RTL_TSAD1	0x0024
#define RTL_TSAD2	0x0028
#define RTL_TSAD3	0x002c
#define RTL_RBSTART	0x0030
#define RTL_ERBCR	0x0034
#define RTL_ERSR	0x0036
#define RTL_CR		0x0037
#define  RTL_CR_BUFE		0x01
#define  RTL_CR_TE		0x04
#define  RTL_CR_RE		0x08
#define  RTL_CR_RST		0x10
#define RTL_CAPR	0x0038
#define RTL_CBR		0x003a
#define RTL_IMR		0x003c
#define  RTL_IMR_ROK		0x0001
#define  RTL_IMR_RER		0x0002
#define  RTL_IMR_TOK		0x0004
#define  RTL_IMR_TER		0x0008
#define  RTL_IMR_RXOVW		0x0010
#define  RTL_IMR_PUN_LinkChg	0x0020
#define  RTL_IMR_FOVW		0x0040
#define  RTL_IMR_LenChg		0x2000
#define  RTL_IMR_TimeOut	0x4000
#define  RTL_IMR_SERR		0x8000
#define RTL_ISR		0x003e
#define RTL_TCR		0x0040
#define  RTL_TCR_CLRABT		0x00000001
#define  RTL_TCR_TXRR_SHIFT	4
#define  RTL_TCR_MXDMA_SHIFT	8
#define  RTL_TCR_CRC		0x00010000
#define  RTL_TCR_LBK0		0x00020000
#define  RTL_TCR_LBK1		0x00040000
#define  RTL_TCR_HWVERID_B_SHIFT 22
#define  RTL_TCR_IFG0		0x01000000
#define  RTL_TCR_IFG1		0x02000000
#define  RTL_TCR_HWVERID_A_SHIFT 26
#define RTL_RCR		0x0044
#define  RTL_RCR_AAP		0x00000001
#define  RTL_RCR_APM		0x00000002
#define  RTL_RCR_AM		0x00000004
#define  RTL_RCR_AB		0x00000008
#define  RTL_RCR_AER		0x00000010
#define  RTL_RCR_WRAP		0x00000080
#define  RTL_RCR_MXDMA_SHIFT	8
#define  RTL_RCR_RBLEN0		0x00000800
#define  RTL_RCR_RBLEN1		0x00001000
#define  RTL_RCR_RXFTH_SHIFT	13
#define  RTL_RCR_RER8		0x00010000
#define  RTL_RCR_MulERINT	0x00020000
#define  RTL_RCR_ERTH_SHIFT	24
#define RTL_TCTR	0x0048
#define RTL_MPC		0x004c
#define RTL_9346CR	0x0050
#define  RTL_9346CR_EEM1	0x80
#define  RTL_9346CR_EEM0	0x40
#define  RTL_9346CR_EECS	0x08
#define  RTL_9346CR_EESK	0x04
#define  RTL_9346CR_EEDI	0x02
#define  RTL_9346CR_EEDO	0x01
#define  EE_WRITE_CMD		0x05
#define  EE_READ_CMD		0x06
#define  EE_ERASE_CMD		0x07
#define RTL_CONFIG0	0x0051
#define RTL_CONFIG1	0x0052
#define RTL_TimerInt	0x0054
#define RTL_MSR		0x0058
#define  RTL_MSR_RXPF		0x01
#define  RTL_MSR_TXPF		0x02
#define  RTL_MSR_LINKB		0x04
#define  RTL_MSR_SPEED_10	0x08
#define  RTL_MSR_Aux_Status	0x10
#define  RTL_MSR_RXFCE		0x40
#define  RTL_MSR_TXFCE		0x80
#define RTL_CONFIG3	0x0059
#define RTL_CONFIG4	0x005a
#define  MDIO_DIR		0x80
#define  MDIO_DATA_OUT		0x04
#define  MDIO_DATA_IN		0x02
#define  MDIO_CLK		0x01
#define  MDIO_WRITE0		MDIO_DIR
#define  MDIO_WRITE1		(MDIO_DIR | MDIO_DATA_OUT)
#define RTL_HLTCLK	0x005b
#define RTL_MULINT	0x005c
#define RTL_RERID	0x005e
#define RTL_TSAD	0x0060
#define RTL_BMCR	0x0062
#define  RTL_BMCR_FDX		0x0100
#define  RTL_BMCR_RESTART	0x0200
#define  RTL_BMCR_ANE		0x1000
#define  RTL_BMCR_SPD_SET	0x2000
#define  RTL_BMCR_RESET		0x8000
#define RTL_BMSR	0x0064
#define  RTL_BMSR_EXTENDED_CAP	0x0001
#define  RTL_BMSR_JABBER_DETECT	0x0002
#define  RTL_BMSR_LINK_STATUS	0x0004
#define  RTL_BMSR_AUTO_NEG	0x0008
#define  RTL_BMSR_REMOTE_FAULT	0x0010
#define  RTL_BMSR_AUTO_NEG_COMP	0x0020
#define  RTL_BMSR_10_BASE_T_HD	0x0800
#define  RTL_BMSR_10_BASE_T_FD	0x1000
#define  RTL_BMSR_100_BASE_T_HD	0x2000
#define  RTL_BMSR_100_BASE_T_FD	0x4000
#define  RTL_BMSR_100_BASE_T4	0x8000
#define RTL_ANAR	0x0066
#define  RTL_ANAR_SELECTOR	0x001f
#define  RTL_ANAR_10		0x0020
#define  RTL_ANAR_10FD		0x0040
#define  RTL_ANAR_TX		0x0080
#define  RTL_ANAR_TXFD		0x0100
#define  RTL_ANAR_T4		0x0200
#define  RTL_ANAR_PAUSE		0x0400
#define  RTL_ANAR_RF		0x2000
#define  RTL_ANAR_ACK		0x4000
#define  RTL_ANAR_NP		0x8000
#define RTL_ANLPAR	0x0068
#define RTL_ANER	0x006a
#define RTL_DIS		0x006c
#define RTL_FCSC	0x006e
#define RTL_NWAYTR	0x0070
#define RTL_REC		0x0072
#define RTL_CSCR	0x0074
#define  RTL_CSCR_PASS_SCR	0x0001
#define  RTL_CSCR_CON_STATUS_EN	0x0004
#define  RTL_CSCR_CON_STATUS	0x0008
#define  RTL_CSCR_F_CONNECT	0x0020
#define  RTL_CSCR_F_LINK_100	0x0040
#define  RTL_CSCR_JBEN		0x0080
#define  RTL_CSCR_HEART_BEAT	0x0100
#define  RTL_CSCR_LD		0x0200
#define  RTL_CSCR_LINKOK	0x0400	/* undoc */
#define  RTL_CSCR_LINKCHANGE	0x0800	/* undoc and doesn't work */
#define  RTL_CSCR_TESTFUN	0x8000
#define RTL_PHY1_PARM	0x0078
#define RTL_TW_PARM	0x007c
#define RTL_PHY2_PARM	0x0080
#define RTL_CRC0	0x0084
#define RTL_CRC1	0x0085
#define RTL_CRC2	0x0086
#define RTL_CRC3	0x0087
#define RTL_CRC4	0x0088
#define RTL_CRC5	0x0089
#define RTL_CRC6	0x008a
#define RTL_CRC7	0x008b
#define RTL_Wakeup0	0x008c
#define RTL_Wakeup1	0x0094
#define RTL_Wakeup2	0x009c
#define RTL_Wakeup3	0x00a4
#define RTL_Wakeup4	0x00ac
#define RTL_Wakeup5	0x00b4
#define RTL_Wakeup6	0x00bc
#define RTL_Wakeup7	0x00c4
#define RTL_LSBCRC0	0x00cc
#define RTL_LSBCRC1	0x00cd
#define RTL_LSBCRC2	0x00ce
#define RTL_LSBCRC3	0x00cf
#define RTL_LSBCRC4	0x00d0
#define RTL_LSBCRC5	0x00d1
#define RTL_LSBCRC6	0x00d2
#define RTL_LSBCRC7	0x00d3
#define RTL_CONFIG5	0x00d8

#endif
