#ifndef __SOUND_I810REG_H
#define __SOUND_I810REG_H

#define I810_REGSPACE		0x40

#define PI_BDBAR		0x00
#define PI_CIV			0x04
#define PI_LVI			0x05
#define PI_SR			0x06
#define  SR_DCH				0x0001
#define  SR_CELV			0x0002
#define  SR_LVBCI			0x0004
#define  SR_BCIS			0x0008
#define  SR_FIFOE			0x0010
#define PI_PICB			0x08
#define PI_PIV			0x0a
#define PI_CR			0x0b
#define  CR_RPBM			0x01
#define  CR_RR				0x02
#define  CR_LVBIE			0x04
#define  CR_FEIE			0x08
#define  CR_IOCE			0x10
#define PO_BDBAR		0x10
#define PO_CIV			0x14
#define PO_LVI			0x15
#define PO_SR			0x16
#define PO_PICB			0x18
#define PO_PIV			0x1a
#define PO_CR			0x1b
#define MC_BDBAR		0x20
#define MC_CIV			0x24
#define MC_LVI			0x25
#define MC_SR			0x26
#define MC_PICB			0x28
#define MC_PIV			0x2a
#define MC_CR			0x2b
#define GLOB_CNT		0x2c
#define  GLOB_CNT_GIE			0x00000001
#define  GLOB_CNT_COLD_RESET		0x00000002
#define  GLOB_CNT_WARM_RESET		0x00000004
#define  GLOB_CNT_SHUT_OFF		0x00000008
#define  GLOB_CNT_PRIE			0x00000010
#define  GLOB_CNT_SRIE			0x00000020
#define  GLOB_CNT_TRIE			0x00000040
#define  GLOB_CNT_SIS_PCM_2		0x00000000
#define  GLOB_CNT_SIS_PCM_4		0x00000040
#define  GLOB_CNT_SIS_PCM_6		0x00000080
#define  GLOB_CNT_SIS_PCM_246_MASK	0x000000c0
#define  GLOB_CNT_ICH_PCM_2		0x00000000
#define  GLOB_CNT_ICH_PCM_4		0x00100000
#define  GLOB_CNT_ICH_PCM_6		0x00200000
#define  GLOB_CNT_ICH_PCM_246_MASK	0x00300000
#define  GLOB_CNT_ICH_PCM_20BIT		0x00400000
#define  GLOB_CNT_ICH_PCM_SPDIF_NONE	0x00000000
#define  GLOB_CNT_ICH_PCM_SPDIF_78	0x40000000
#define  GLOB_CNT_ICH_PCM_SPDIF_69	0x80000000
#define  GLOB_CNT_ICH_PCM_SPDIF_1011	0xc0000000
#define  GLOB_CNT_ICH_PCM_SPDIF_MASK	0xc0000000
#define GLOB_STA		0x30
#define  GLOB_STA_GSCI			0x00000001
#define  GLOB_STA_MIINT			0x00000002
#define  GLOB_STA_MOINT			0x00000004
#define  GLOB_STA_NF_SPINT		0x00000010
#define  GLOB_STA_PIINT			0x00000020
#define  GLOB_STA_POINT			0x00000040
#define  GLOB_STA_MINT			0x00000080
#define  GLOB_STA_PCR			0x00000100
#define  GLOB_STA_SCR			0x00000200
#define  GLOB_STA_PRI			0x00000400
#define  GLOB_STA_SRI			0x00000800
#define  GLOB_STA_SLOT12_BIT1		0x00001000
#define  GLOB_STA_SLOT12_BIT2		0x00002000
#define  GLOB_STA_SLOT12_BIT3		0x00004000
#define  GLOB_STA_RCS			0x00008000
#define  GLOB_STA_AD3			0x00010000
#define  GLOB_STA_MD3			0x00020000
#define  GLOB_STA_MULTICHAN_CAP		0x00300000
#define  GLOB_STA_SAMPLE_16_20		0x00400000
#define  GLOB_STA_SAMPLE_CAP		0x00c00000
#define  GLOB_STA_M2INT			0x01000000
#define  GLOB_STA_P2INT			0x02000000
#define  GLOB_STA_SPINT			0x04000000
#define  GLOB_STA_BCS			0x08000000
#define  GLOB_STA_TCR			0x10000000
#define  GLOB_STA_TRI			0x20000000
#define ACC_SEMA		0x34
#define  ACC_SEMA_CAS			0x01

#endif
