#ifndef __SOUND_WSSREG_H
#define __SOUND_WSSREG_H

#define WSS_REGSPACE	3

#define R0_TRD		0x20
#define R0_MCE		0x40
#define R0_INIT		0x80

#define R2_INT		0x01
#define R2_PRDY		0x02
#define R2_PLR		0x04
#define R2_PUR		0x08
#define R2_SER		0x10
#define R2_CRDY		0x20
#define R2_CLR		0x40
#define R2_CUL		0x80

#define I0_MGE		0x20
#define I0_LSS0		0x40
#define I0_LSS1		0x80

#define I1_MGE		0x20
#define I1_RSS0		0x40
#define I1_RSS1		0x80

#define I2_LX1IM	0x40
#define I2_LX1OM	0x80

#define I3_RX1IM	0x40
#define I3_RX1OM	0x80

#define I4_LX2IM	0x40
#define I4_LX2OM	0x80

#define I5_RX2IM	0x40
#define I5_RX2OM	0x80

#define I6_LD1OM	0x80

#define I7_RD1OM	0x80

#define I8_C2SL		0x01
#define I8_CFS0		0x02
#define I8_CFS1		0x04
#define I8_CFS2		0x08
#define I8_SM		0x10
#define I8_16B		0x40

#define I9_PEN		0x01
#define I9_CEN		0x02
#define I9_SDC		0x04
#define I9_CAL0		0x08
#define I9_CAL1		0x10
#define I9_PPIO		0x40
#define I9_CPIO		0x80

#define I10_IEN		0x02
#define I10_DTM		0x04
#define I10_DEN		0x08
#define I10_OSM0	0x10
#define I10_OSM1	0x20
#define I10_XCTL0	0x40
#define I10_XCTL1	0x80

#define I11_ORL0	0x01
#define I11_ORL1	0x02
#define I11_ORR0	0x04
#define I11_ORR1	0x08
#define I11_DRS		0x10
#define I11_ACI		0x20
#define I11_PUR		0x40
#define I11_COR		0x80

#define I12_PATTERN	0x8A
#define I12_CMS0	0x20
#define I12_CMS1	0x40

#define I16_DACZ	0x01
#define I16_SPE		0x02
#define I16_SF0		0x04
#define I16_SF1		0x08
#define I16_PMCE	0x10
#define I16_CMCE	0x20

#define I17_HPF		0x01

#define I18_LD2IM	0x40
#define I18_LD2OM	0x80

#define I19_RD2IM	0x40
#define I19_RD2OM	0x80

#define I22_CS2		0x01
#define I22_SRE		0x80

#define I23_XRAE	0x08

#define I24_PU		0x01
#define I24_PO		0x02
#define I24_CO		0x04
#define I24_CU		0x08
#define I24_PI		0x10
#define I24_CI		0x20

#define I26_MIM		0x80

#define I27_LOS0	0x20
#define I27_LOS1	0x40
#define I27_LOM		0x80

#define I28_SM		0x10
#define I28_16B		0x40

#define I29_ROS0	0x20
#define I29_ROS1	0x40
#define I29_ROM		0x80

#define X2_MBST		0x20
#define X2_LMOM		0x40
#define X2_LMIM		0x80

#define X3_MBST		0x20
#define X3_RMOM		0x40
#define X3_RMIM		0x80

#define X4_IFM		0x10
#define X4_LIS0		0x20
#define X4_LIS1		0x40
#define X4_MIMR		0x80

#define X5_RIS0		0x20
#define X5_RIS1		0x40

#define X6_LFMM		0x80

#define X7_RFMM		0x80

#define X8_LSPM		0x80

#define X9_RSPM		0x80

#define X11_IFSE	0x20
#define X11_RD1IM	0x40
#define X11_LD1IM	0x80

#define X16_LWM		0x80

#define X17_RWM		0x80

#define X18_DLEN	0x01
#define X18_PSH		0x04
#define X18_DSPD1	0x08
#define X18_3DEN	0x10
#define X18_AUX1R	0x20
#define X18_PAE		0x80

#define X19_FMS0	0x10
#define X19_FMS1	0x20
#define X19_FMS2	0x40

#define X24_BRES	0x01
#define X24_DMCLK	0x02
#define X24_VCEN	0x04
#define X24_WTEN	0x08
#define X24_VCF1	0x40
#define X24_VCIE	0x80

#define X26_JR0		0x01
#define X26_JR1		0x02
#define X26_ZERO	0x08
#define X26_CONSW	0x20

#define X27_CLK		0x01
#define X27_DOUT	0x02
#define X27_DIN_EEN	0x04
#define X27_ICH		0x80

#define X28_FM		0x01
#define X28_PROC	0x02
#define X28_DAC1	0x04
#define X28_ADC1	0x08
#define X28_MIX		0x10
#define X28_VREF	0x20
#define X28_SRC		0x40
#define X28_PDWN	0x80

#define X29_SPORT	0x01
#define X29_DAC2	0x02
#define X29_MIXCD	0x04
#define X29_RESET	0x80

#define X30_IMV		0x02
#define X30_WDT		0x04
#define X30_IMPU	0x08
#define X30_IWSS	0x10
#define X30_ISB		0x20
#define X30_ICTRL	0x40
#define X30_CWSS	0x80

#endif
