#ifndef __HOST_EHCIREG_H
#define __HOST_EHCIREG_H

#define EHCI_REGSPACE	0x100

#define EHCI_CAPLENGTH		0x00
#define EHCI_HCIVERSION		0x02
#define EHCI_HCSPARAMS		0x04
#define  EHCI_HCSPARAMS_N_PORTS			0x0000000f
#define  EHCI_HCSPARAMS_PPC			0x00000010
#define  EHCI_HCSPARAMS_PRR			0x00000080
#define  EHCI_HCSPARAMS_N_PCC			0x00000f00
#define  EHCI_HCSPARAMS_N_CC			0x0000f000
#define  EHCI_HCSPARAMS_P_INDICATOR		0x00010000
#define  EHCI_HCSPARAMS_DEBUG_PORT		0x00f00000
#define EHCI_HCCPARAMS		0x08
#define  EHCI_HCCPARAMS_64BIT			0x00000001
#define  EHCI_HCCPARAMS_PROG_FRAME_LIST		0x00000002
#define  EHCI_HCCPARAMS_ASYNC_SCHED_PACK	0x00000004
#define  EHCI_HCCPARAMS_ISO_THRESH_MICROFRAMES	0x00000070
#define  EHCI_HCCPARAMS_ISO_THRESH_FRAME	0x00000080
#define  EHCI_HCCPARAMS_EECP			0x0000ff00
#define EHCI_HCSP_PORTROUTE	0x0c

#define EHCIOP_USBCMD		0x00
#define  EHCIOP_USBCMD_RUN_STOP		0x00000001
#define  EHCIOP_USBCMD_HCRESET		0x00000002
#define  EHCIOP_USBCMD_FRAME_LIST_SIZE	0x0000000c
#define  EHCIOP_USBCMD_PERIODIC_EN	0x00000010
#define  EHCIOP_USBCMD_ASYNC_EN		0x00000020
#define  EHCIOP_USBCMD_ASYNC_DOORBELL	0x00000040
#define  EHCIOP_USBCMD_LIGHT_RESET	0x00000080
#define  EHCIOP_USBCMD_ASYNC_PARK_COUNT	0x00000300
#define  EHCIOP_USBCMD_ASYNC_PARK_EN	0x00000800
#define  EHCIOP_USBCMD_INT_THRESHOLD	0x00ff0000
#define EHCIOP_USBSTS		0x04
#define  EHCIOP_USBSTS_USBINT		0x00000001
#define  EHCIOP_USBSTS_USBERRINT	0x00000002
#define  EHCIOP_USBSTS_PORT_CHANGE	0x00000004
#define  EHCIOP_USBSTS_FRAME_ROLLOVER	0x00000008
#define  EHCIOP_USBSTS_SYSTEM_ERROR	0x00000010
#define  EHCIOP_USBSTS_ASYNC_ADVANCE	0x00000020
#define  EHCIOP_USBSTS_HALTED		0x00001000
#define  EHCIOP_USBSTS_RECLAMATION	0x00002000
#define  EHCIOP_USBSTS_PERIODIC_STATUS	0x00004000
#define  EHCIOP_USBSTS_ASYNC_STATUS	0x00008000
#define EHCIOP_USBINTR		0x08
#define EHCIOP_FRINDEX		0x0c
#define EHCIOP_CTRLDSSEGMENT	0x10
#define EHCIOP_PERIODICLISTBASE	0x14
#define EHCIOP_ASYNCLISTADDR	0x18
#define EHCIOP_CONFIGFLAG	0x40
#define  EHCIOP_CONFIGFLAG_CF			0x00000001
#define EHCIOP_PORTSC		0x44

#define EHCI_EECP_BIOS_SYNC	0x01
#define EHCI_USBLEGSUP_BIOS_SEM		0x02
#define EHCI_USBLEGSUP_OS_SEM		0x03
#define EHCI_USBLEGSTSCTLS		0x04
#define  EHCI_USBLEGSTSCTLS_EN_SMI_COMPLETE	0x00000001
#define  EHCI_USBLEGSTSCTLS_EN_SMI_ERROR	0x00000002
#define  EHCI_USBLEGSTSCTLS_EN_SMI_PORT_CHANGE	0x00000004
#define  EHCI_USBLEGSTSCTLS_EN_SMI_FL_ROLLOVER	0x00000008
#define  EHCI_USBLEGSTSCTLS_EN_SMI_SYS_ERROR	0x00000010
#define  EHCI_USBLEGSTSCTLS_EN_SMI_ASYNC_ADV	0x00000020
#define  EHCI_USBLEGSTSCTLS_EN_SMI_OS_OWNER	0x00002000
#define  EHCI_USBLEGSTSCTLS_EN_SMI_PCI_COMMAND	0x00004000
#define  EHCI_USBLEGSTSCTLS_EN_SMI_BAR_ENABLE	0x00008000
#define  EHCI_USBLEGSTSCTLS_SMI_COMPLETE	0x00010000
#define  EHCI_USBLEGSTSCTLS_SMI_ERROR		0x00020000
#define  EHCI_USBLEGSTSCTLS_SMI_PORT_CHANGE	0x00040000
#define  EHCI_USBLEGSTSCTLS_SMI_FL_ROLLOVER	0x00080000
#define  EHCI_USBLEGSTSCTLS_SMI_SYS_ERROR	0x00100000
#define  EHCI_USBLEGSTSCTLS_SMI_ASYNC_ADV	0x00200000
#define  EHCI_USBLEGSTSCTLS_SMI_OS_OWNER	0x20000000
#define  EHCI_USBLEGSTSCTLS_SMI_PCI_COMMAND	0x40000000
#define  EHCI_USBLEGSTSCTLS_SMI_BAR_ENABLE	0x80000000

#endif
