#ifndef __SYS_TTYDEFAULTS_H
#define __SYS_TTYDEFAULTS_H

#define TTYDEF_IFLAG	(BRKINT | ISTRIP | ICRNL | IMAXBEL | IXON | IXANY)
#define TTYDEF_OFLAG	(OPOST | ONLCR | XTABS)
#define TTYDEF_LFLAG	(ECHO | ICANON | ISIG | IEXTEN | ECHOE|ECHOKE|ECHOCTL)
#define TTYDEF_CFLAG	(CREAD | CS7 | PARENB | HUPCL)
#define TTYDEF_SPEED	(B9600)

#define CTRL(x)		((x) & 0x1f)
#define CEOF		CTRL('D')
#define CEOL		0xff
#define CERASE		0x7f
#define CERASE2		CTRL('H')
#define CINTR		CTRL('C')
#define CSTATUS		0
#define CKILL		CTRL('U')
#define CMIN		1
#define CQUIT		CTRL('\\')
#define CSUSP		CTRL('Z')
#define CTIME		0
#define CDSUSP		0
#define CSTART		CTRL('Q')
#define CSTOP		CTRL('S')
#define CLNEXT		CTRL('V')
#define CDISCARD	0
#define CWERASE		0
#define CREPRINT	0
#define CEOT		CEOF
#define CBRK		CEOL
#define CRPRNT		CREPRINT
#define CFLUSH		CDISCARD

#endif
