#ifndef __KERNEL_VM_H
#define __KERNEL_VM_H

#include <ARCH/SETUP.H>
#include <SPAD/VM.H>
#include <SPAD/WQ.H>

extern MTX VM_MUTEX;

extern WQ WRITEBACK_WAIT;
extern WQ FREEMEM_ABOVE;
extern WQ FREE_ENTITIES;

void MEMORY_BALANCE(void);
void VM_ADD_PAGE(PAGE *p, int res);
int VM_RELEASE_PAGES(unsigned long from, unsigned long to_reserve, unsigned long to);
void KERNEL_VM_INIT(void);
void KERNEL_VM_INIT_2(void);
void VM_RESET_ZONES(int bank);
void VM_COUNT_ZONES(unsigned long *kernel, unsigned long *io, unsigned long *high);
void VM_REFRESH_WATERMARKS(void);

void KERNEL_TRANSFER_VM_STATE(int type_from, int type_to);

extern int IO_IN_PROGRESS;
extern int MAX_IO_IN_PROGRESS;
extern unsigned long VM_ENTITIES;

#define VM_MAXIO		64
#define VM_MAXIO_LIMIT		65536
#define MAX_UPCALL_TRIES	16
extern unsigned VM_PRESSURE;
unsigned long KERNEL_FREE_MEM(void);
void CACHE_UPCALL(void);

void *MAKE_USER_SIZES(size_t s);
int MAKE_USER_PAGES(void);

typedef struct {
	size_t size;
} USER_SIZE_DESC;

extern USER_SIZE_DESC *USER_SIZE_DESCS;
extern PAGE *USER_PAGE_DESCS;

void VM_CHECK_MAGICS(void);

#endif
