#ifndef __LIB_LIBC_GETTEXT_LIBGNUINTL_H
#define __LIB_LIBC_GETTEXT_LIBGNUINTL_H

#include <LIBINTL.H>
#include <SYS/TYPES.H>

#undef gettext
#undef dgettext
#undef ngettext
#undef dngettext

#define HAVE_STDINT_H		1
#define HAVE_STRDUP		1
#define HAVE_ALLOCA_H		1
#define HAVE_UNISTD_H		1
#define HAVE_SYS_PARAM_H	1
#define HAVE_GETCWD		1
#define HAVE_STPCPY		1
#define HAVE_MEMPCPY		1
#define HAVE_LIMITS_H		1
#define HAVE_TSEARCH		1
#define HAVE_ALLOCA		1
#if !defined(__GNUC__) || (__GNUC__ <= 2 && __GNUC_MINOR__ < 96)
#else
#define HAVE_BUILTIN_EXPECT	1
#endif
#define HAVE_MMAP		1
#define HAVE_MUNMAP		1
#define HAVE_STDDEF_H		1
#define HAVE_STRING_H		1
#define HAVE_STDLIB_H		1
#define HAVE_LANGINFO_CODESET	1
#define HAVE_SETLOCALE		1
#define HAVE_STRCASECMP		1
#define HAVE_LOCALE_NULL	1
#define HAVE_LC_MESSAGES	1
#define HAVE_STRTOUL		1
#ifdef __LONG_LONG_SUPPORTED
#define HAVE_LONG_LONG		1
#endif
#ifdef __LONG_DOUBLE_SUPPORTED
#define HAVE_LONG_DOUBLE	1
#endif
#define HAVE_WINT_T		1
#define HAVE_WCHAR_T		1
#define HAVE_SNPRINTF		1
#define HAVE_ASPRINTF		1
#define HAVE_WCSLEN		1
#define HAVE_INTTYPES_H_WITH_UINTMAX	1
#define HAVE_POSIX_PRINTF	1
#define LOCALEDIR		"ETC.:/LOCALE"
#define LOCALE_ALIAS_PATH	"ETC.:/LOCALE.ALIAS"

#define HAVE_ICONV		1
#define ICONV_CONST
#define INTDIV0_RAISES_SIGFPE	0
#define VMS			0
#define WIDE_CHAR_VERSION	0
#define ENABLE_RELOCATABLE	0

#define YYSTACK_USE_ALLOCA	1
#define YYLSP_NEEDED		0
#define YYMAXDEPTH		0

char *dcigettext (const char *domainname, const char *msgid1, const char *msgid2, int plural, unsigned long int n, int category);

#endif
