#include <ERRNO.H>
#include <SPAD/SYNC.H>
#include <ARCH/BITOPS.H>

#include <PTHREAD.H>
#include "PTHREAD.H"

int pthread_spin_init(pthread_spinlock_t *s, int pshared)
{
	s->__spin = 0;
	return 0;
}

int pthread_spin_destroy(pthread_spinlock_t *s)
{
	return 0;
}

int pthread_spin_lock(pthread_spinlock_t *s)
{
	/* if I use while instead of if and goto, gcc generates terrible code */
	x:
	if (__unlikely(__CMPXCHGI((int *)&s->__spin, 0, 1) != 0)) {
		KERNEL$THREAD_YIELD();
		goto x;
	}
	return 0;
}

int pthread_spin_trylock(pthread_spinlock_t *s)
{
	return __unlikely(__CMPXCHGI((int *)&s->__spin, 0, 1) != 0) ? EBUSY : 0;
}

int pthread_spin_unlock(pthread_spinlock_t *s)
{
#if __DEBUG >= 1
	if (__unlikely(!s->__spin))
		KERNEL$SUICIDE("pthread_spin_unlock: unlocking non-locked spinlock");
#endif
	s->__spin = 0;
	return 0;
}

