#ifndef __BOOT_BIND_SYS_H
#define __BOOT_BIND_SYS_H

#ifdef __SPAD__
#include <SYS/TYPES.H>
#else
#define __u8 unsigned char
#define __u16 unsigned short
#define __u32 unsigned
#endif

typedef struct {
	__u8 method;
	__u8 namelen;
	__u16 pad;
	__u32 uncompressed_len;
	__u32 compressed_len;
	__u32 magic;
} BIND_HEADER;

#define BIND_MAGIC		0x454c4946

#define BIND_ALIGN		4

#define METHOD_UNCOMPRESSED	0x01
#define METHOD_ZLIB		0x02
#define METHOD_END		0x0f

#define ZLIB_WINDOW_BITS	15

#endif
